> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/nemo-platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/nemo-platform/_mcp/server.

# Add workspace member

POST /apis/entities/v2/workspaces/{workspace}/members
Content-Type: application/json

Add a new member to the workspace with specified roles.

This creates role bindings for the specified principal with the given roles.
By default, this endpoint waits for the roles to propagate before returning.
Use `wait_role_propagation=false` to skip waiting (useful for bulk operations).

Example:

```
POST /apis/entities/v2/workspaces/ml-team/members
{
    "principal": "user@example.com",
    "roles": ["Editor"]
}
```

Reference: https://docs.nvidia.com/nemo-platform/nemo-platform/v0.3.0/documentation/reference/api-reference/entity-store/add-workspace-member-apis-entities-v-2-workspaces-workspace-members-post

## Request

### Path parameters

- `workspace` (string, required)

### Query parameters

- `wait_role_propagation` (boolean, optional, default: true) — If true, wait for roles to propagate before returning (default: true). Set to false for bulk operations.

### Body (application/json)

- `principal` (string, required) — The principal identifier (email, user ID, or group ID)
- `roles` (list of string, optional, default: ["Editor"]) — List of roles to grant to the principal

## Response

### 201

Successful Response

- `principal` (string, required) — The principal identifier
- `roles` (list of string, required) — List of roles granted to the principal
- `granted_at` (datetime, optional) — Earliest date when a role was granted to this principal
- `granted_by` (string, optional) — Who granted the earliest role

## Examples

**Request**

```json
{
  "principal": "user@example.com"
}
```

**Response**

```json
{
  "principal": "string",
  "roles": [
    "string"
  ],
  "granted_at": "2024-01-15T09:30:00Z",
  "granted_by": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.example.com/apis/entities/v2/workspaces/workspace/members"

payload = { "principal": "user@example.com" }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.example.com/apis/entities/v2/workspaces/workspace/members';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"principal":"user@example.com"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.example.com/apis/entities/v2/workspaces/workspace/members"

	payload := strings.NewReader("{\n  \"principal\": \"user@example.com\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.example.com/apis/entities/v2/workspaces/workspace/members")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"principal\": \"user@example.com\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.example.com/apis/entities/v2/workspaces/workspace/members")
  .header("Content-Type", "application/json")
  .body("{\n  \"principal\": \"user@example.com\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.example.com/apis/entities/v2/workspaces/workspace/members', [
  'body' => '{
  "principal": "user@example.com"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.example.com/apis/entities/v2/workspaces/workspace/members");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"principal\": \"user@example.com\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["principal": "user@example.com"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.example.com/apis/entities/v2/workspaces/workspace/members")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```